#version 120

uniform sampler2D texSampler0_2D; 
uniform samplerCube texSampler0_Cube;
uniform int colorChannel;
uniform int textureType;

varying vec2 varTexCoords;


void main()
{
	vec4 col;
	if(textureType == 0) // 2D-Texture
	{
		col = texture2D(texSampler0_2D, varTexCoords);
	}
	else // Cube-Texture
	{
		// Top Row
		col = vec4(1.0,1.0,1.0,1.0);
		if(varTexCoords.y >= 0.6666)
		{
			// +Y 
			if(varTexCoords.x >= 0.25 && varTexCoords.x <= 0.5)
			{
				float x = (varTexCoords.x - 0.25) * 8.0 - 1.0;
				float z = (varTexCoords.y - 0.6666) * 6.0 - 1.0;
				col = textureCube(texSampler0_Cube, vec3(x, 1.0, z));
			}
			else 
				discard;
		}
		// Mid Row
		else if(varTexCoords.y < 0.6666 && varTexCoords.y > 0.33333)
		{
			// -X
			if(varTexCoords.x >= 0.0 && varTexCoords.x <= 0.25)
			{
				float z = 1.0 - (varTexCoords.x) * 8.0;
				float y = (varTexCoords.y - 0.3333) * 6.0 - 1.0;
				col = textureCube(texSampler0_Cube, vec3(-1.0, y, z));
			}
			// -Z
			else if(varTexCoords.x > 0.25 && varTexCoords.x <= 0.5)
			{
				float x = (varTexCoords.x - 0.25) * 8.0 - 1.0;
				float y = (varTexCoords.y - 0.3333) * 6.0 - 1.0;
				col = textureCube(texSampler0_Cube, vec3(x, y, -1.0));
			}
			// +X
			else if(varTexCoords.x > 0.5 && varTexCoords.x <= 0.75)
			{
				float z = (varTexCoords.x - 0.5) * 8.0 - 1.0;
				float y = (varTexCoords.y - 0.3333) * 6.0 - 1.0;
				col = textureCube(texSampler0_Cube, vec3(1.0, y, z));
			}
			// +Z
			else
			{
				float x = 1.0 - (varTexCoords.x - 0.75) * 8.0;
				float y = (varTexCoords.y - 0.3333) * 6.0 - 1.0;
				col = textureCube(texSampler0_Cube, vec3(x, y, 1.0));
			}
		}
		// Bottom Row
		else if(varTexCoords.y <= 0.3333)
		{
			// -Y
			if(varTexCoords.x >= 0.25 && varTexCoords.x <= 0.5)
			{
				float x = (varTexCoords.x - 0.25) * 8.0 - 1.0;
				float z = 1.0 - (varTexCoords.y) * 6.0;
				col = textureCube(texSampler0_Cube, vec3(x, -1.0, z));
			}
			else
				discard;
		}

	}

	if(colorChannel == 0)
		gl_FragColor = vec4(col.x, 0.0, 0.0, 1.0);
	else if(colorChannel == 1)
		gl_FragColor = vec4(0.0, col.y, 0.0, 1.0);
	else if(colorChannel == 2)
		gl_FragColor = vec4(0.0, 0.0, col.z, 1.0);
	else if(colorChannel == 3)
		gl_FragColor = vec4(col.a, col.a, col.a, 1.0);
	else
		gl_FragColor = vec4(col.x, col.y, col.z, 1.0);
}