#version 330 core

// Input vertex data, different for all executions of this shader.
in vec2 vertexPosition_screenspace;
in vec2 vertexUV;

// Output data ; will be interpolated for each fragment.
out vec2 uv;

uniform vec2 screenSize;

void main(){

        // Output position of the vertex, in clip space
        vec2 vertexPosition_homoneneousspace = vertexPosition_screenspace - screenSize/2;
        vertexPosition_homoneneousspace /= screenSize/2;
	gl_Position =  vec4(vertexPosition_homoneneousspace,0,1);
	
	// UV of the vertex. No special space for this one.
        uv = vertexUV;
}

